VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   5985
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   9435
   LinkTopic       =   "Form1"
   ScaleHeight     =   5985
   ScaleWidth      =   9435
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox picCanvas 
      Height          =   5235
      Left            =   1020
      ScaleHeight     =   5175
      ScaleWidth      =   6735
      TabIndex        =   0
      Top             =   180
      Width           =   6795
   End
   Begin VB.Label Label1 
      Caption         =   "Label1"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   315
      Left            =   60
      TabIndex        =   1
      Top             =   5640
      Width           =   9255
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'A  simple object-based drawing editor.
'We create, move and erase squares
'You can easily extend this to include different graphical classes
'e.g., circles, lines, etc.

'This program illustrates
' - how to create simple object-based interactive graphics in VB
' - how to use a collection
' - how to use a class
Option Explicit

Dim colSquares As New Collection
Dim selectedSquare As Square
Const Margin As Integer = 5

Private Sub Form_Load()
    'Redraws the image  when the window is covered/uncovered
    picCanvas.AutoRedraw = True
     'The canvas look and drawing behaviour
    picCanvas.ScaleMode = vbPixels
    picCanvas.ForeColor = vbBlue  'All objects will be drawn in blue
    picCanvas.BackColor = vbWhite 'Background canvas is white
    
    Form1.ScaleMode = vbPixels
    Form1.Caption = "Draw1: A simple Drawing Editor"
    
    Label1.Caption = "Left-click to create a square, select a square to move it, right-click a square to erase it"
End Sub

'Make the controls fit nicely on the window after a user resizes it
Private Sub Form_Resize()
    picCanvas.Left = Margin
    picCanvas.Top = Margin
    picCanvas.Width = Form1.ScaleWidth - (2 * Margin)
    picCanvas.Height = Form1.ScaleHeight - (2 * Margin) - Label1.Height
    Label1.Left = Margin
    Label1.Top = Form1.ScaleHeight - Label1.Height - Margin
End Sub

' If we click into an empty area create a square
' if we click on a square, select it
' if we right-click on a square, erase it.
Private Sub picCanvas_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim iSquare As Square
    
    If Button = 1 Then
        'if we click on a square, make it the selected square
        If CanvasSelectSquare(X, Y) = False Then
            'otherwise create and draw a new square
            CanvasDrawSquare X, Y
        End If
    ElseIf Button = 2 Then
        'if we right-click on a square, erase it
        CanvasEraseSquare X, Y
    End If
End Sub

'If a square had been selected and we are now moving the mouse, then move the square
'We do this by changing the square's coordinates, erasing the canvas, and redrawing all squares
'held in the collection.
Private Sub picCanvas_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim iSquare As Square
    
    If Button <> 1 Then Exit Sub    'Ignor moves if mouse button one isn't pressed
    
    'If no square has been selected, an error will be generated and we just exit
    On Error GoTo Error_noSelectedSquare
     
    'Reset the coordinates of the square to the current mouse position and redraw the canvas
    selectedSquare.XLeft = X
    selectedSquare.YTop = Y
    CanvasRedrawAll
    Exit Sub
Error_noSelectedSquare:
    'We don't have to do anything on error except exit
End Sub

'When the mouse is released, there is no more selected square.
Private Sub picCanvas_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Set selectedSquare = Nothing
End Sub

'''
''' We do much of the actual checking and drawing work on the canvas in the routines below
'''

'if the coordinate is in a square, make it the selected square and return True, otherwise False
Private Function CanvasSelectSquare(ByVal X As Integer, ByVal Y As Integer) As Boolean
    Dim iSquare As New Square
    
    For Each iSquare In colSquares
        If iSquare.Inside(X, Y) Then
            Set selectedSquare = iSquare
            CanvasSelectSquare = True
            Exit Function
        End If
    Next iSquare
    CanvasSelectSquare = False
End Function

'Create and draw a new square and add it to the collection
Private Sub CanvasDrawSquare(ByVal X As Integer, ByVal Y As Integer)
    Dim iSquare As New Square
    Const SquareWidth As Integer = 10  'The width of the squares
    
    iSquare.XLeft = X
    iSquare.YTop = Y
    iSquare.Extent = SquareWidth
    Set iSquare.Canvas = picCanvas
    iSquare.Draw
    colSquares.Add iSquare
End Sub

'See if a  square contains the x,y coordinates and erase it
Private Sub CanvasEraseSquare(ByVal X As Integer, ByVal Y As Integer)
    Dim I As Integer
    Dim iSquare As Square
    For I = 1 To colSquares.Count
        Set iSquare = colSquares.Item(I)
        If iSquare.Inside(X, Y) Then
            colSquares.Remove I
            Set iSquare = Nothing
            CanvasRedrawAll
            Exit Sub
        End If
    Next I
End Sub

'Clear the canvas, and redraw all the squares in the collection
Private Sub CanvasRedrawAll()
    Dim iSquare As Square
    picCanvas.Cls
    For Each iSquare In colSquares
        iSquare.Draw
    Next iSquare
End Sub
